#ifndef __CACHEDMAP_H__
#define __CACHEDMAP_H__

/* CachedMap.h
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | Transport Empire -> |
 * +---------------------+
 * 
 * 
 */

#include <string>
#include "Tile.h"
#include "Map.h"
#include "ClientSocket.h"
#include "MapChunkPacket.h"

namespace TEmpire {

/* Class CachedMap:
 * 
 * Stores only parts of the map, which consists of
 * - Tiles
 * - More to add later
 */

class CachedMap : public Map {
protected:
  ClientSocket *Client;

public:
  // Static variables
  static std::string Author;
  static std::string Name;
  static std::string Abbreviation;
  static long Count;
  
  // Constructor and destructor
  CachedMap();
  virtual ~CachedMap();

  // Getters/Setters
  void SetClient(ClientSocket *Client);
  
  // Create an empty map. This is a map without Tile objects.
  void CreateEmptyMap(unsigned short width, unsigned short height);
  
  // Prefetch a piece of the map from the server
  void Prefetch(unsigned short xStart, unsigned short yStart, 
      unsigned short xEnd, unsigned short yEnd);
  
  // Process received tiles
  void Process(MapChunkPacket *packet);
};

} // namespace TEmpire

#endif // __CACHEDMAP_H__
