#ifndef __CLIENTSOCKET_H__
#define __CLIENTSOCKET_H__

/* ClientSocket.h
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | TRANSPORT EMPIRE -> |
 * +---------------------+
 * 
 * 
 */

#include <string>
#include "Socket.h"
#include "RakClientInterface.h"

namespace TEmpire {

/* Class ClientSocket:
 * 
 * Connects to a server socket. This class can send and receive messages from
 * the server and convert them to Packet objects.
 */

class ClientSocket {
protected:
  RakClientInterface *rakClient;
  
public:
  // Static variables
  static std::string Author;
  static std::string Name;
  static std::string Abbreviation;
  static long Count;
  
  // Constructor and Destructor
  ClientSocket();
  virtual ~ClientSocket();
  
  // Connect to a server
  bool Connect(std::string hostname, unsigned short port);
  
  // Is this class connected to a server?
  bool IsConnected();

  // Send a packet
  bool SendPacket(TEmpire::Packet *packet);

  // Receive a packet
  TEmpire::Packet *ReceivePacket();
};

} // namespace TEmpire

#endif // __CLIENTSOCKET_H__
