/* Map.cpp
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | Transport Empire -> |
 * +---------------------+
 * 
 * 
 */

#include "Map.h"
#include <stdlib.h>

using TEmpire::Map;

// Static variables
std::string Map::Author = "Hellfire";
std::string Map::Name = "Map";
std::string Map::Abbreviation = "MAPx";
long Map::Count = 0;

// Constructor
Map::Map() {
  Count++;
  
  // Initialize data
  Width = Height = 0;
  Tiles = NULL;
}

// Destructor
Map::~Map() {
  Count--;
  
  // Check if we have tile data
  if(Tiles != NULL) {
    for(int i = 0; i < Width * Height; i++) {
      if(Tiles[i] != NULL) {
        delete Tiles[i];
      }
    }
    
    delete Tiles;
  }
}

// Generate a random map
void Map::Random(unsigned short width, unsigned short height) {
  // Allocate memory
  Tiles = new Tile*[width * height];
  
  // Set Width and Height
  Width = width;
  Height = height;
  
  // Generate tiles (very simplified version)
  unsigned short prevHeight = 255;
  for(int i = 0; i < width * height; i++) {
    if(rand() > RAND_MAX / 2) {
      Tiles[i] = new Tile(0);
    } else {
      Tiles[i] = new Tile(1);
    }
  }
}

// Get an individual tile
Tile *Map::GetTile(unsigned short X, unsigned short Y) {
  return Tiles[Y * Width + X];
}

