#ifndef __MAPCHUNKPACKET_H__
#define __MAPCHUNKPACKET_H__

/* MapChunkPacket.h
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | Transport Empire -> |
 * +---------------------+
 * 
 * 
 */

#include "Packet.h"
#include "Map.h"
#include <string>

namespace TEmpire {
  
/* Class MapChunkPacket:
 * 
 * A simple packet, for testing purposes.
 */

class MapChunkPacket : public Packet {
public:
  // Static variables
  static std::string Author;
  static std::string Name;
  static std::string Abbreviation;
  static long Count;
  
  // Content of the packet
  unsigned short XStart;
  unsigned short XEnd;
  unsigned short YStart;
  unsigned short YEnd;
  
  // Pointer to the map
  Map *PMap;
  
  // Pointers to received tiles
  Tile **ReceivedTiles;
  
  // Constructor and Destructor
  MapChunkPacket();
  virtual ~MapChunkPacket();
  
  // Abstract methods from Packet
  virtual unsigned char GetType();
  virtual unsigned long Length();
  virtual unsigned long FillBuffer(unsigned char *Buffer, unsigned long Buflen);
  virtual bool ParseBuffer(unsigned char *buffer, unsigned long buflen);
};

} // namespace TEmpire

#endif // __MAPCHUNKPACKET_H__
