#ifndef __MAPREQUESTPACKET_H__
#define __MAPREQUESTPACKET_H__

/* MapRequestPacket.h
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | Transport Empire -> |
 * +---------------------+
 * 
 * 
 */

#include "Packet.h"
#include <string>

namespace TEmpire {
  
/* Class MapRequestPacket:
 * 
 * A packet for requesting pieces of the map. The payload of the packet
 * consists of four fields: xStart, xEnd, yStart and yEnd, which define a 
 * region of the map.
 */

class MapRequestPacket : public Packet {
public:
  // Static variables
  static std::string Author;
  static std::string Name;
  static std::string Abbreviation;
  static long Count;
  
  // Content of the packet
  unsigned short XStart;
  unsigned short XEnd;
  unsigned short YStart;
  unsigned short YEnd;
  
  // Constructor and Destructor
  MapRequestPacket();
  virtual ~MapRequestPacket();
  
  // Abstract methods from Packet
  virtual unsigned char GetType();
  virtual unsigned long Length();
  virtual unsigned long FillBuffer(unsigned char *Buffer, unsigned long Buflen);
  virtual bool ParseBuffer(unsigned char *buffer, unsigned long buflen);
};

} // namespace TEmpire

#endif // __MAPREQUESTPACKET_H__
