#ifndef __PACKETFACTORY_H__
#define __PACKETFACTORY_H__

/* PacketFactory.h
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | TRANSPORT EMPIRE -> |
 * +---------------------+
 * 
 * 
 */

#include <string>
#include "Packet.h"

namespace TEmpire {

/* Class PacketFactory:
 * 
 * Singleton.
 * Centralizes all code to create Packet objects. In detail, the code to
 * reconstruct a Packet object from a stream is located in this class.
 */

class PacketFactory {
  // PacketFactory is a Singleton
private:
	PacketFactory();
  static PacketFactory *Instance;
public:
  static PacketFactory *GetInstance();

  // Static variables
  static std::string Author;
  static std::string Name;
  static std::string Abbreviation;
  static long Count;
  
  // Reconstruct a packet
  Packet *Reconstruct(unsigned char *buffer, unsigned int bufLen);
};

} // namespace TEmpire

#endif // __PACKETFACTORY_H__
