#ifndef __SOCKET_H__
#define __SOCKET_H__

/* Socket.h
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | TRANSPORT EMPIRE -> |
 * +---------------------+
 * 
 * 
 */

#include <string>
#include "Packet.h"

namespace TEmpire {
  
/* Class Socket:
 * 
 * Provides the base functionality for socket communication.
 * Known subclasses: ClientSocket, ServerSockt
 */

class Socket {
protected:
  // Socket identifier
  int Sock;
  
public:
  // Static variables
  static std::string Author;
  static std::string Name;
  static std::string Abbreviation;
  static long Count;
  
  // Constructor and Destructor
  Socket();
  virtual ~Socket();
  
  // Send a packet
  bool SendPacket(Packet *packet);

  // Receive a packet
  Packet* ReceivePacket();
};

} // namespace TEmpire

#endif // __SOCKET_H__
