#ifndef __TILE_H__
#define __TILE_H__

/* Tile.h
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | TRANSPORT EMPIRE -> |
 * +---------------------+
 * 
 * 
 */

#include <string>

/* Class Tile:
 * 
 * Stores all the information on one tile:
 * - Height
 * - More to add later
 */

class Tile {
public:
  // Static variables
  static std::string Author;
  static std::string Name;
  static std::string Abbreviation;
  static long Count;

  // Constructor and destructor
  Tile();
  Tile(unsigned short Height);
  ~Tile();
  
  // Height of the tile
  unsigned short Height;
};

#endif // __TILE_H__
