#ifndef __SERVERSOCKET_H__
#define __SERVERSOCKET_H__

/* ServerSocket.h
 * Author: Jeroen van Montfort
 * 
 * +------------Oo.------+
 * | TRANSPORT EMPIRE -> |
 * +---------------------+
 * 
 * 
 */

#include <string>
#include "Packet.h"
#include "RakServerInterface.h"

namespace TEmpire {
  
/* Class ServerSocket:
 * 
 * Creates a server socket. This class can send and receive messages from one
 * client and convert them to Packet objects.
 */

class ServerSocket {
protected:
  RakServerInterface *rakServer;
  
public:
  // Static variables
  static std::string Author;
  static std::string Name;
  static std::string Abbreviation;
  static long Count;
  
  // Constructor and Destructor
  ServerSocket();
  ~ServerSocket();
  
  // Open a port
  bool OpenPort(unsigned short port);
  
  // Send a packet
  bool SendPacket(TEmpire::Packet *packet);

  // Receive a packet
  TEmpire::Packet *ReceivePacket();
};

} // namespace TEmpire

#endif // __SERVERSOCKET_H__
